package cn.iocoder.yudao.module.llm.service.dataset;

import cn.iocoder.yudao.module.llm.controller.admin.dataset.vo.DatasetFilesPageReqVO;
import cn.iocoder.yudao.module.llm.controller.admin.dataset.vo.DatasetFilesSaveReqVO;
import cn.iocoder.yudao.module.llm.dal.dataobject.dataset.DatasetFilesDO;
import cn.iocoder.yudao.module.llm.dal.mysql.dataset.DatasetFilesMapper;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;


import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.llm.enums.ErrorCodeConstants.*;

/**
 * 数据集数据文件 Service 实现类
 *
 * @author 华大大模型
 */
@Service
@Validated
public class DatasetFilesServiceImpl implements DatasetFilesService {

    @Resource
    private DatasetFilesMapper datasetFilesMapper;

    @Override
    public Long createDatasetFiles(DatasetFilesSaveReqVO createReqVO) {
        // 插入
        DatasetFilesDO datasetFiles = BeanUtils.toBean(createReqVO, DatasetFilesDO.class);
        datasetFilesMapper.insert(datasetFiles);
        // 返回
        return datasetFiles.getId();
    }

    @Override
    public void updateDatasetFiles(DatasetFilesSaveReqVO updateReqVO) {
        // 校验存在
        validateDatasetFilesExists(updateReqVO.getId());
        // 更新
        DatasetFilesDO updateObj = BeanUtils.toBean(updateReqVO, DatasetFilesDO.class);
        datasetFilesMapper.updateById(updateObj);
    }

    @Override
    public void deleteDatasetFiles(Long id) {
        // 校验存在
        validateDatasetFilesExists(id);
        // 删除
        datasetFilesMapper.deleteById(id);
    }

    private void validateDatasetFilesExists(Long id) {
        if (datasetFilesMapper.selectById(id) == null) {
            throw exception(DATASET_FILES_NOT_EXISTS);
        }
    }

    @Override
    public DatasetFilesDO getDatasetFiles(Long id) {
        return datasetFilesMapper.selectById(id);
    }

    @Override
    public PageResult<DatasetFilesDO> getDatasetFilesPage(DatasetFilesPageReqVO pageReqVO) {
        return datasetFilesMapper.selectPage(pageReqVO);
    }

}